{
  description = "teapot is a static site generator using pure nix";

  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixpkgs-unstable";
    flake-utils.url = "github:numtide/flake-utils";
    markdoll.url = "git+https://codeberg.org/0x57e11a/markdoll.git";
  };

  outputs = { self, nixpkgs, flake-utils, ... }@inputs:
    flake-utils.lib.eachDefaultSystem (system: let 
      pkgs = import nixpkgs { 
        inherit system;
        overlays = [ self.overlays.default ];
      };
    in {
      packages = import ./default.nix { inherit pkgs; };
    }) // {
      overlays = {
        default = final: prev: {
          markdoll = inputs.markdoll.packages.${final.system}.markdoll;
        } // import ./default.nix { pkgs = final; };
      };
    };
}